<?
/* 
   This file is part of the 'Science Fair In A Box' project
   SFIAB Website: http://www.sfiab.ca

   Copyright (C) 2005 Sci-Tech Ontario Inc <info@scitechontario.org>
   Copyright (C) 2005 James Grant <james@lightbox.org>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation, version 2.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/
?>
<?
 require("../common.inc.php");
 auth_required('admin');
 require("judges.inc.php");

 send_header("Judging Teams Projects");
 ?>
<script language="javascript" type="text/javascript">
function checkall(what)
{
	for(i=0;i<document.forms.teamstimeslots.elements.length;i++)
	{
		if(document.forms.teamstimeslots.elements[i].name==what+"[]")
			document.forms.teamstimeslots.elements[i].checked=true;

	}


	return false;
}
function checknone(what)
{
	for(i=0;i<document.forms.teamstimeslots.elements.length;i++)
	{
		if(document.forms.teamstimeslots.elements[i].name==what+"[]")
			document.forms.teamstimeslots.elements[i].checked=false;

	}

	return false;
}
function checkinvert(what)
{

	for(i=0;i<document.forms.teamstimeslots.elements.length;i++)
	{
		if(document.forms.teamstimeslots.elements[i].name==what+"[]")
			document.forms.teamstimeslots.elements[i].checked=!document.forms.teamstimeslots.elements[i].checked;

	}

	return false;
}
</script>



 <?

	echo "<a href=\"index.php\">&lt;&lt; ".i18n("Back to Administration")."</a>\n";
	echo "<a href=\"judges.php\">&lt;&lt; ".i18n("Back to Judges")."</a>\n";
 	echo "<br />";
 	echo "<br />";

 if($_GET['action']=="delete" && $_GET['delete'])
 {
 	mysql_query("DELETE FROM judges_teams_timeslots_link WHERE id='".$_GET['delete']."'");
	echo happy(i18n("Judging team timeslot successfully removed"));
 }

 if($_GET['action']=="empty" && $_GET['empty'])
 {
 	mysql_query("DELETE FROM judges_teams_timeslots_link WHERE judges_teams_id='".$_GET['empty']."'");
	echo happy(i18n("Judging team timeslots successfully removed"));
 }

 if($_POST['action']=="assign")
 {
	//the db handles the uniqueness (to ensure the same timeslot isnt assigned to the same team more than once)
	//so all we'll do here is just mass insert without regards for whats already there.
	foreach($_POST['teams'] AS $tm)
	{
		foreach($_POST['timeslots'] AS $ts)
		{
			mysql_query("INSERT INTO judges_teams_timeslots_link (judges_teams_id,judges_timeslots_id,year) VALUES ('$tm','$ts','".$config['FAIRYEAR']."')");

		}
	}
	echo happy(i18n("%1 Timeslots assigned to %2 teams",array(count($_POST['timeslots']),count($_POST['teams']))));
 }


 if($_GET['action']=="edit" && $_GET['edit'])
 {
 	echo "<form name=\"teamstimeslots\" method=\"post\" action=\"judges_teams_timeslots.php\">";
	$team=getJudgingTeam($_GET['edit']);

	echo "<b>".$team['name']." (#".$team['num'].")</b><br />";
	$memberlist="&nbsp;&nbsp;";
	foreach($team['members'] AS $member)
	{
		if($member['captain']=="yes")
			$memberlist.="<i>";
		$memberlist.=$member['firstname']." ".$member['lastname'];
		if($member['captain']=="yes")
			$memberlist.="</i>";
		$memberlist.=", ";
	}
	$memberlist=substr($memberlist,0,-2);
	echo $memberlist;
	echo "<br />";


	$q=mysql_query("SELECT 
				projects.id,
				projects.projectnumber,
				projects.title,
				registrations.status
			FROM
				projects,
				registrations
			WHERE
				projectnumber is not null AND
				registrations.status='complete' AND
				projects.registrations_id=registrations.id AND
				projects.year='".$config['FAIRYEAR']."'
			ORDER BY
				projectnumber
			");
			echo mysql_error();
	$numprojects=mysql_num_rows($q);
	echo "<br />";
	echo "<select name=\"project_id\">";
	echo "<option value=\"\">Choose Project to Assign to Timeslot</option>\n";
	while($r=mysql_fetch_object($q))
	{
		echo "<option value=\"$r->id\">$r->projectnumber - $r->title</option>\n";
	}
	echo "</select>";
	echo "$numprojects projects listed";
				

	//get the timeslots that this team has.
	$q=mysql_query("SELECT 
				judges_timeslots.id,
				judges_timeslots.date,
				judges_timeslots.starttime,
				judges_timeslots.endtime
			FROM
				judges_timeslots,
				judges_teams,
				judges_teams_timeslots_link
			WHERE
				judges_teams.id='".$team['id']."' AND
				judges_teams.id=judges_teams_timeslots_link.judges_teams_id AND
				judges_timeslots.id=judges_teams_timeslots_link.judges_timeslots_id
			ORDER BY
				date,starttime
			");


	$numslots=mysql_num_rows($q);
	echo "<br />";
	echo "<br />";

	echo "<table class=\"summarytable\">";
	echo "<tr>";
	echo "<th>Timeslot</th>";
	echo "<th>Project</th>";
	echo "</tr>";


	while($r=mysql_fetch_object($q))
	{
		echo "<tr><td>";

		if($show_date)
			echo "$r->date ";
		echo substr($r->starttime,0,-3);
		echo " - ";
		echo substr($r->endtime,0,-3);
		echo "</td><td>";
		
		$projq=mysql_query("SELECT
					projects.projectnumber,
					projects.id,
					projects.title
				FROM
					projects,
					judges_teams_timeslots_projects_link
				WHERE
					judges_teams_timeslots_projects_link.judges_timeslots_id='$r->id' AND
					judges_teams_timeslots_projects_link.judges_teams_id='".$team['id']."' AND
					judges_teams_timeslots_projects_link.projects_id=projects.id AND
					judges_teams_timeslots_projects_link.year='".$config['FAIRYEAR']."'
				ORDER BY
					projectnumber
				");

	echo mysql_Error();
		while($proj=mysql_fetch_object($projq))
		{
			echo "$proj->projectnumber - $proj->title <br />";

		}

		echo "</td></tr>";
	}
	echo "</table>";




	echo "</form>";
 }
 else
 {
	echo "<input type=\"hidden\" name=\"action\" value=\"assign\">";

	echo "<table class=\"summarytable\">";
	echo "<tr>";
	echo "<th>".i18n("Team")."</th>";
	echo "<th>".i18n("Timeslots and Projects")."</th>";
	echo "</tr>";

	$teams=getJudgingTeams();
	foreach($teams AS $team)
	{
		echo "<tr>";
		echo "<td>";
		echo "<b>".$team['name']." (#".$team['num'].")</b><br />";
		$memberlist="";
		foreach($team['members'] AS $member)
		{
			echo "&nbsp;&nbsp;";
			if($member['captain']=="yes")
				echo "<i>";
			echo $member['firstname']." ".$member['lastname']."<br />";
			if($member['captain']=="yes")
				echo "</i>";

		}
		echo "</td>";
		echo "<td>";
		//get the timeslots that this team has.
		$q=mysql_query("SELECT 
					judges_teams_timeslots_link.id,
					judges_timeslots.date,
					judges_timeslots.starttime,
					judges_timeslots.endtime
				FROM
					judges_timeslots,
					judges_teams,
					judges_teams_timeslots_link
				WHERE
					judges_teams.id='".$team['id']."' AND
					judges_teams.id=judges_teams_timeslots_link.judges_teams_id AND
					judges_timeslots.id=judges_teams_timeslots_link.judges_timeslots_id
				ORDER BY
					date,starttime
				");
		$numslots=mysql_num_rows($q);

		echo "<a href=\"judges_teams_projects.php?action=edit&edit=".$team['id']."\">Edit team project assignments</a>";

		echo "<table class=summarytable style=\"margin-left: 0px\">";

		while($r=mysql_fetch_object($q))
		{
			echo "<tr><td>";

			if($show_date)
				echo "$r->date ";
			echo substr($r->starttime,0,-3);
			echo " - ";
			echo substr($r->endtime,0,-3);
			echo "</td><td>";

			//FIXME: list the projects :)


			echo "</td></tr>";
		}
		echo "</table>";

		echo "</td>";
		echo "</tr>";
	}

 echo "</table>";

 }

 send_footer();
?>
